/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)mfish.c    1.0     02/24/00

The authors are with the Laboratory for Image and Video Engineering
at The University of Texas at Austin, and can be reached at
wade@.ece.utexas.edu.
*/

#include <stdlib.h>
#include "mfish.h"
#include "my_matrix_stuff.h"

int freeMFISH(MFISH image)
{
   int i;

   if (image == 0) {
      return 0;
   }

   for(i=0;i<6;i++) {
      if(image[i]) {
         freeByteMatrix(image[i]);
      }
   }

   free(image);
   return 1;
}

MFISH allocateMFISH(char *DAPI, char *fluor1, char *fluor2,
                    char *fluor3, char *fluor4, char *fluor5,
                    int numRows, int numColumns)
{
   MFISH image2read = malloc(6*sizeof(unsigned char**));

   image2read[0] = allocateByteMatrix(numRows, numColumns);
   readImageAs2DByte(DAPI, image2read[0], &numRows, &numColumns);
   image2read[1] = allocateByteMatrix(numRows, numColumns);
   readImageAs2DByte(fluor1, image2read[1], &numRows, &numColumns);
   image2read[2] = allocateByteMatrix(numRows, numColumns);
   readImageAs2DByte(fluor2, image2read[2], &numRows, &numColumns);
   image2read[3] = allocateByteMatrix(numRows, numColumns);
   readImageAs2DByte(fluor3, image2read[3], &numRows, &numColumns);
   image2read[4] = allocateByteMatrix(numRows, numColumns);
   readImageAs2DByte(fluor4, image2read[4], &numRows, &numColumns);
   image2read[5] = allocateByteMatrix(numRows, numColumns);
   readImageAs2DByte(fluor5, image2read[5], &numRows, &numColumns);

   return image2read;
}

int writeMFISH(MFISH image2write, int numRows, int numColumns, int imageType,
               char *DAPI, char *fluor1, char *fluor2,
               char *fluor3, char *fluor4, char *fluor5)
{
   writeImageAs2DByte(DAPI, image2write[0], numRows, numColumns, imageType);
   writeImageAs2DByte(fluor1, image2write[1], numRows, numColumns, imageType);
   writeImageAs2DByte(fluor2, image2write[2], numRows, numColumns, imageType);
   writeImageAs2DByte(fluor3, image2write[3], numRows, numColumns, imageType);
   writeImageAs2DByte(fluor4, image2write[4], numRows, numColumns, imageType);
   writeImageAs2DByte(fluor5, image2write[5], numRows, numColumns, imageType);

   return 1;
}
