/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.
 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
   
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.
       
Programmers:    Wade Schwartzkopf
Version:        @(#)miscfunc.c    1.0     02/24/00

The authors are with the Laboratory for Image and Video Engineering
at The University of Texas at Austin, and can be reached at
wade@.ece.utexas.edu.
*/

#include <math.h>
#include "miscfunc.h"

int minInt(int first, int second)
{
   if(first<second) { return first; }
   else { return second; }
}

int maxInt(int first, int second)
{
   if(first>second) { return first; }
   else { return second; }
}

double maxDouble(double first, double second)
{
   if(first>second) { return first; }
   else { return second; }
}

double l2norm(int *vector1, int *vector2, int vectorLength)
{
   int i;
   double temp, sum;

   sum=0.0;
   for(i = 0; i < vectorLength; i++) {
      temp=vector1[i]-vector2[i];
      sum=sum+(temp*temp);
   }

   temp=sqrt(sum);

   return temp;
}
