/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)my_matrix_stuff.h    1.0     02/24/00

The authors are with the Laboratory for Image and Video Engineering
at The University of Texas at Austin, and can be reached at
wade@.ece.utexas.edu.
*/

/*  Set of utility functions to deal with images in memory  */

/*  Allocate a 2D byte matrix */
unsigned char** allocateByteMatrix(int height, int width);

/*  Deallocate a 2D byte matrix */
int freeByteMatrix(unsigned char **byteMatrix);

/*  Copy image */
void copy_image(unsigned char** inputImage, unsigned char** outputImage, int rows, int cols);

/*  Copy portion of image */
void copy_square(unsigned char** inputImage, unsigned char** outputImage, int lowX, int highX, int lowY, int highY);

/*  Convert image format  */
void byteToTwoD(unsigned char* ByteImage, unsigned char** byte2DImage, int rows, int cols);

/*  Convert image format */
void twoDToByte(unsigned char** byte2DImage, unsigned char* ByteImage, int rows, int cols);

/*  Read image from file */
int readImageAs2DByte(char* imageFile, unsigned char** byte2DImage, int* rows, int* cols);

/*  Write image to file */
void writeImageAs2DByte(char* imageFile, unsigned char** byte2DImage, int rows, int cols, int imageType);
