/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)points.h    1.0     02/24/00

The authors are with the Laboratory for Image and Video Engineering
at The University of Texas at Austin, and can be reached at
wade@.ece.utexas.edu.
*/

// Point data type
struct point {
   int x;
   int y;
};

// Linked list of points
struct pointList {
   struct point value;
   struct pointList* next;
};

// Add item to linked list
struct pointList* addPoint(struct pointList* currentList, int newx, int newy);

// Delete linked list
void freePointList(struct pointList* currentList);

// Save the coordinates of all non-zero pixels in an image to a linked list
struct pointList* listPoints(unsigned char** inputImage, int rows, int cols);

// Send linked list to standard out
void printPointList(struct pointList* listToPrint);

// For each point in newPoints, set that coordinate in inputImage to value
void addToImage(unsigned char** inputImage, struct pointList* newPoints, int value);
